// -------------------------------------------- //
// Cal: Calbiate the AD and Da value            //
// Compiler: Turbo   C++ 3.0, Mode Large        //
// -------------------------------------------- //

#include "PIO.H"
#include "stdlib.h"

static int wSysConfig=0;
//float fAdData[1000];
//WORD  AdValue[1000];
WORD wBase,wIrq;
WORD wDELAY=23,time=0;
WORD EEP,MSB,LSB,AdVal;

//---------------------------------------------------------
WORD Pio821_Delay(WORD wDownCount)
{
  WORD h,l;
  int count;
  wDownCount &= 0xff;
  if (wDownCount<1) wDownCount=1;

 // Clock in=2M --> count 4000 = 1 ms ,count 1 = 0.5 us
  l=wDownCount&0xff;
  wDownCount=wDownCount / 256;
  h=wDownCount&0xff;

  outportb(wBase+0xcc,0xb4);	             // CW of 8254,mode_0, counter_2
  outportb(wBase+0xc8,l);	             // counter_2 low byte first
  outportb(wBase+0xc8,h);	             // counter_2 high byte ,0x07D0=2000

  outportb(wBase+0xcc,0x80);	             // latch counter_2
  l=inportb(wBase+0xc8);	             // delay starting two clks
  h=inportb(wBase+0xc8);

  for (count=32767;count>0;count--)
  {
	  outportb(wBase+0xcc,0x80);         // latch counter_2
	  l=inportb(wBase+0xc8);
	  h=inportb(wBase+0xc8);
	  if (h>=0x80) return NoError;
  }
  return TimeOut;
}

//---------------------------------------------------
void SetupTimer(WORD wCoef)
{
   WORD   cmd,lsb,msb;
   outportb(wBase+0xcc, 0xb4);
   outportb(wBase+0xc8, wCoef&0xff);
   outportb(wBase+0xc8, wCoef>>8);
}

//-------------------------------------------------------
WORD Pio821_AdsPacer(float fAdVal[],WORD wNum, WORD wSamplingDiv)
{
   WORD    wVal,wZERO,i;
   WORD    MSB,LSB,wTime,sts;
   float   fMAX;

   switch (wSysConfig)
   {
       case 0 :  fMAX=(float)5.0  ;   break;
       case 1 :  fMAX=(float)2.5  ;   break;
       case 2 :  fMAX=(float)1.25 ;   break;
       case 3 :  fMAX=(float)0.625;   break;
   }

   outportb(wBase+0xe4,0xf2);      // Set trigger mode=Pacer trigger
   SetupTimer(wSamplingDiv);       // sampling rate=2M/wSamplingDiv

   for(i=0;i<wNum;i++)
   {

	do{
		sts=inportb(wBase+0xec);
	}while((sts&0x01)==0);

      MSB=inportb(wBase+0xd4);
      LSB=inportb(wBase+0xd0);

   fAdVal[i]=(((float)(((MSB<<8)+LSB)&0xfff)-2048.0)/2048.0)*fMAX;
  }

  outportb(wBase+0xe4,0xf0);        		  // close Mode
}

//-------------------------------------------------------
WORD  Pio821_SetChannelConfig(WORD wAdChannel,WORD wConfig)
{

	WORD wDELAY;
	outportb(wBaseAddr+0x10,(UCHAR)wAdChannel);
	outportb(wBaseAddr+0x14,(UCHAR)wConfig);
	wSysConfig=wConfig;

	switch (wSysConfig)
	{
	 case 0 : wDELAY=23;      break;
	 case 1 : wDELAY=23;      break;
	 case 2 : wDELAY=23;      break;
	 case 3 : wDELAY=23;      break;

	 case 0x10 : wDELAY=23;   break;
	 case 0x11 : wDELAY=28;   break;
	 case 0x12 : wDELAY=140;  break;
	 case 0x13 : wDELAY=1300; break;
      }
     // P1002_Delay(wDELAY*4);
	return NoError;
	outportb(wBase+0xe0,wAdChannel);
	Pio821_Delay(wDELAY *4);
	return NoError;
}
void pio_821_da(WORD iVal)
{
WORD MSB,LSB;
MSB=(iVal>>8)&0x0f;
LSB=(iVal&0xff);
outportb(wBase+0xd0,LSB);              /* iVal : 0x000 - 0xfff */
outportb(wBase+0xd4,MSB);

}
// --------------------------------------------------------------
// AUX2= D/O = CS of EEP            AUX3= D/O = SK of EEP
// AUX4= D/O = DI of EEP            AUX5= D/I = DO of EEP
// --------------------------------------------------------------

void COMM()                                  // send start 2-bit (0,1)
{
EEP=0x4; outportb(wBase+0xec,EEP);        // CS=H
EEP=0x5; outportb(wBase+0xec,EEP);        // SK=H
					// DI=0
EEP=0x7; outportb(wBase+0xec,EEP);        // SK=L
EEP=0x5; outportb(wBase+0xec,EEP);        // DI=1
//EEP=0x1c; outportb(wBase+0xec,EEP);        // SK=H
}

// --------------------------------------------------------------
void WR_BYTE(int val)                           // send the next 8-bit
{
int i,j;

for (i=0; i<8; i++)
    {
    EEP=EEP&0x5; outportb(wBase+0xec,EEP);   // SK=L
    j=val&0x80; val=val<<1;
    if (j==0)                              // DI=0
       {
       EEP=EEP&0x3; outportb(wBase+0xec,EEP);
       }
    else                                   // DI=1
       {
       EEP=EEP|0x4; outportb(wBase+0xec,EEP);
       }
    EEP=EEP|0x2; outportb(wBase+0xec,EEP);   // SK=H
    }
}

// --------------------------------------------------------------
RD_BYTE()                                  // read the next 8-bit
{
int i,j,val,k;

val=0x80; k=0;
for (i=0; i<8; i++)
    {
    EEP=EEP&0x5; outportb(wBase+0xec,EEP);   // SK=L
    j=(inportb(wBase+0xec))&0x08;
    if (j!=0) k+=val;                      // DO=1
    EEP=EEP|2; outportb(wBase+0xec,EEP);   // SK=H
    val=val>>1;
    }
return(k);
}

// --------------------------------------------------------------
void EEP_WR_EN()                               /* write Enable */
{
COMM();
WR_BYTE(0x30);                            /* write enable command */
EEP=EEP&0x5; outportb(wBase+0xec,EEP);      /* SK=L */
EEP=EEP&0x6; outportb(wBase+0xec,EEP);      /* CS=L */
EEP=EEP&0x3; outportb(wBase+0xec,EEP);      /* DI=0 */
}

/* -------------------------------------------------------------- */
void EEP_WR_DIS()                             /* write Disable */
{
COMM();
WR_BYTE(0);                              /* write disable command */
EEP=EEP&0x5; outportb(wBase+0xec,EEP);     /* SK=L */
EEP=EEP&0x6; outportb(wBase+0xec,EEP);     /* CS=L */
EEP=EEP&0x3; outportb(wBase+0xec,EEP);     /* DI=0 */
}

/* -------------------------------------------------------------- */
void EEP_WRITE(int ADDR, int HI, int LO)   /* write 16-bit data to EEP */
{
int i,j,k;

COMM();
ADDR=ADDR|0x40; WR_BYTE(ADDR);        /* write command & address  */
WR_BYTE(HI);                          /* high 8-bit data          */
WR_BYTE(LO);                          /* low  8-bit data          */

EEP=EEP&0x5; outportb(wBase+0xec,EEP);  /* SK=L */
EEP=EEP&0x6; outportb(wBase+0xec,EEP);  /* CS=L */
EEP=EEP&0x3; outportb(wBase+0xec,EEP);  /* DI=0 */

for (i=0; i<10; i++)                  /* delay>250 ns (for EEP)   */
{
EEP=EEP|0x08; outportb(wBase+3,EEP);  /* SK=H */
EEP=EEP&0x14; outportb(wBase+3,EEP);  /* SK=L */
}

EEP=EEP|0x04; outportb(wBase+3,EEP);  /* CS=H */

for (k=0; k<10; k++)                  /* wait until write finish  */
for (i=0; i<30000; i++)
    {
    //EEP=EEP|0x08; outportb(wBase+3,EEP);/* SK=H */
    //j=inportb(wBase+7)&0x20;
    //EEP=EEP&0x14;
    outportb(wBase+0xec,EEP);/* SK=L */
    //if (j!=0) return(0);                /* write is finished      */
    }
EEP=EEP&0x1; outportb(wBase+0xec,EEP);    /* CS=L */
                              /* error --> time out ?   */
}

/* -------------------------------------------------------------- */
void EEP_READ(int ADDR, int *HI, int *LO) /* read 16-bit data from EEP */
{
int i,j,k;

COMM();
ADDR=ADDR|0x80; WR_BYTE(ADDR);          /* read command & address */
EEP=EEP&0x3; outportb(wBase+0xec,EEP);    /* DI=0 */
EEP=EEP&0x5; outportb(wBase+0xec,EEP);    /* SK=L */
EEP=EEP|0x2; outportb(wBase+0xec,EEP);    /* SK=H */
EEP=EEP&0x5; outportb(wBase+0xec,EEP);    /* SK=L */
(*HI)=RD_BYTE();                        /* read high 8-bit data   */
(*LO)=RD_BYTE();                        /* read low  8-bit data   */
EEP=EEP&0x5; outportb(wBase+0xec,EEP);    /* SK=L */
EEP=EEP&0x6; outportb(wBase+0xec,EEP);    /* CS=L */
}


int main(void)
{
int  i,j,k1,k2,l1,l2,jj,dd,j1,i1,j2,i2;
int sts;
unsigned int Adstatus=0;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5,High,DaVal,YESNO;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;

char c,DO,ReadBack;
FILE *stream;
WORD op;
clrscr();
// Step 1: Find address-mapping of PIO/PISO cards
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);
printf("\n----------------------- The Configuration Space ------------------");
printf("\nThere are %d PIO-821 Cards in this PC",wBoards);
if (wBoards==0) exit(0);



for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

   printf("\n---------------Step by Step to calibrate----------------");
   printf("\n 1. DA 5V/10V calibrate and AD chip calibrate.");
   printf("\n    (1-1 set the JP2(5V) first.)");
   printf("\n    (1-2 set the JP2(10V))");
   printf("\n    (1-3 input 0V to AD channel=>0.)");
   //printf("\n 2. AD chip calibrate.-->(Please AD ch0 input 0V.)");
   printf("\n 99.Exit.");
   printf("\n--------------------------------------------------------");
   printf("\nPlease choice the options:");
   scanf("%d",&op);
   switch(op)
   {
   	case 1: 
   	        for(;;)
                   {
                     printf("\n1-1.Please keyin the DA value of 5V(Dec 0~4095):");
                     scanf("%d",&DaVal);
                     if (DaVal>4095||DaVal<0)
                     {
                     printf("Out of value!!");
                     exit(0);
                     }     
                     pio_821_da(DaVal);
                     printf("\nPlease measure the AnlogOut value(5.00V) of PIO821 Card");
                     printf("\nThe DA value is 5.00V and save to EEP (1.YES/2.NO/3.Exit):");
                     scanf("%d",&YESNO);
                     if (YESNO==1)
                        {
                          EEP_WR_EN();
                          EEP_WRITE(0,DaVal>>8,(DaVal&0x0ff));
                          EEP_WR_DIS();
	                  break;
                        }
                     else if (YESNO==3){exit(0);}
                  }
                 // break;
        //case 2: 
                  clrscr();       
   	        for(;;)
                   {
                     printf("\n1-2.Please keyin the DA value of 10V(Dec 0~4095):");
                     scanf("%d",&DaVal);
                     if (DaVal>4095||DaVal<0)
                     {
                     printf("Out of value!!");
                     exit(0);
                     }                       
                     pio_821_da(DaVal);
                     printf("\nPlease measure the AnlogOut value(10.00V) of PIO821 Card");
                     printf("\nThe DA value is 10.00V and save to EEP(1.YES/2.NO/3.Exit):");
                     scanf("%d",&YESNO);
                     if (YESNO==1)
                        {
                          EEP_WR_EN();
                          EEP_WRITE(1,DaVal>>8,(DaVal&0x0ff));
                          EEP_WR_DIS();
			  break;
			}
		     else if (YESNO==3){exit(0);}
		  }
	         clrscr();
		 printf("\nPlease input 0V to AD channel 0.Any key to continue...");
		 getch();
                 clrscr();
		 outportb(wBase,0X31);
		 outportb(wBase+0xe0,0x00);      // channel=0 ; G=1
		 Pio821_Delay(23);
		 outportb(wBase+0xe4,0xf1);      // Select trigger mode=Software-trigge
		 outportb(wBase+0xe8,0x01);    // A/D software tirgger
		do{
		    Adstatus+=1;
		   if (Adstatus>65530) break;
		   sts=inportb(wBase+0xec);
		  }while((sts&0x01)==0);
                   
                   outportb(wBase+0xe4,0xf0);        		  // close Mode
		   MSB=inportb(wBase+0xd4)&0xf;
		   //printf("\nMSB:%x",MSB);
		   LSB=inportb(wBase+0xd0);
		   //printf("\nLSB:%x",LSB);
		   AdVal=(MSB<<8)+LSB;
		   
		   printf("\n1-3.The AD chip 0V value (hex):%d (1.Save value to EEP/2.No and Exit):",AdVal);
		   scanf("%d",&YESNO);
		     if (YESNO==1)
			{
			  EEP_WR_EN();
			  EEP_WRITE(2,AdVal>>8,(AdVal&0x0ff));
			  EEP_WR_DIS();
			  break;
			}
		     else if (YESNO==2){exit(0);}
		     break;

	 case 99: exit(0);
	 default: printf("Option is error");
                  
                 
   }
  
 
// Step 2: Enable all D/I/O port
/*outportb(wBase,0X31);	        	     // enable D/I/O
outportb(wBase+0xe0,0);                      // Set channel=0,Gain=0

Pio821_AdsPacer(fAdData,1000,40);          // Sample Rate= 2Mhz/200 = 10k Max

stream=fopen("data.dat","wb+");
for(i=0;i<1000;i++)
   {
    fprintf(stream,"%2.5f\n",fAdData[i]);
   }*/

PIO_DriverClose();
}


