/* DEMO5 : D/A Output without calibration                         */
/* Step1 : run Demo5.exe                                          */
/* step2 : check valtage value by meter                           */
/* -------------------------------------------------------------- */
#include "PIO.H"

void pio_821_da(WORD iVal);

WORD  wBase,wIrq;

int main()
{
int   i,j,k,quit=0;
WORD  wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD  wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char  c;

clrscr();
/* step1 : find address-mapping of PIO/PISO cards                 */
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10); /*for PIO-821    */
printf("\n(1) There are %d PIO-821 Cards in this PC",wBoards);
if ( wBoards==0 )  exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);
						 /* select card_0 */
/* step2 : enable all D/I/O port                                  */
outportb(wBase,0x01);                            /* /RESET -> 1   */

printf("\n\n(2) D/A Output without calibration test\n");
printf("\n\n    1.25V Voltage output to channel(Pin 30 of CON3)");

j=(1.25*4095.0)/5.0;
pio_821_da(j);
getch();

PIO_DriverClose();
}

/* -------------------------------------------------------------- */
void pio_821_da(WORD iVal)
{
WORD MSB,LSB;

MSB=(iVal>>8)&0x0f;
LSB=(iVal&0xff);
outportb(wBase+0xd0,LSB);              /* iVal : 0x000 - 0xfff */
outportb(wBase+0xd4,MSB);

}
