/* -------------------------------------------------------------- */
/* DEMO1.C : PIO-821 D/I/O test                        		  */
/* Step 1  : CON1 connect to CON2 by 20-pin flat cable            */
/* Step 2  : Run DEMO1.EXE					  */
/* -------------------------------------------------------------- */

#include "PIO.H"

WORD wBase,wIrq;

void main(void)
{
int quit,i1,i2,c1,c2,err=0;
int start;
WORD i,wBoards,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c,DO,ReadBack;

clrscr();
/* step 1: find address-mapping of PIO/PISO cards  */
PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);  /* for PIO-821  */
printf("\nThere are %d PIO-821 Cards in this PC",wBoards);
printf("\ntotal board= %d",wBoards);

if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   printf("wSubAux:%d",wSubAux);

   }

printf("\n\nCON1 connect to CON2 by 20-pin flat cable");
printf("\nPass any key to start");
getch();

//PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);
/* step2 : enable all D/I/O port      */
outportb(wBase,1);                                /* /RESET -> 1  */
/* step3 : configuration & initial value setting    */
i=0;

for(;;)
{

i1=i&0xff;
i2=(i+1)&0xff;

outportb(wBase+0xd8,i1);
outportb(wBase+0xdc,i2);
delay(10);
c1=inportb(wBase+0xd8);
c2=inportb(wBase+0xdc);
printf("\nc1:%d and i1: %d",c1,i1);
printf("\nc2:%d and i2: %d",c2,i2);
if(c1!=i1) err=1 ;
if(c2!=i2) err=1 ;

gotoxy(1,10);
printf("DO_L=[%2x] DI_L=[%2x]   DO_H=[%2x] DI_H=[%2x]",i1,c1,i2,c2);
printf(".....OK");
if(getch()=='q'){return;}
delay(10);

if(err==1){
 clrscr();
 printf("\n  Error happen ; Press any key to quit");
 getch();
 return;
  }
i++;

}

//PIO_DriverClose();

}