/* DEMO3 : Save EEPROM DATA TO FILE */
/* Step1 : Run DEMO3.exe            */


#include "PIO.H"

WORD wBase,wIrq;
WORD EepAddr,EepData;
WORD  wN10V[16],wP10V[16],w00mA[16],w20mA[16],EEP;

int main()
{
int  i,i1,i2,j,k;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char  filename[20],c;
FILE  *fp;

clrscr();
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);  /* for PIO-821  */
printf("\n(1) There are %d PIO-821 Cards in this PC",wBoards);
if ( wBoards==0 ) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

printf("\n\nThis demo will save EEPROM data to a file");
printf("\nPress any key to start");
getch();

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

EepAddr=wBase+0xec;
outportb(wBase,0x31);	/* /RESET = 1 */

printf("\n\n(2) Enter file name : ");
scanf("%s",filename);

printf("\n\n(3) Save EEPROM data to %s",filename);
fp=fopen(filename,"wb+");

for (i=0; i<64;i++)
    {
    if (i<16)
      {
      EEP_READ(i,&j,&k);
      wN10V[i]=(j<<8)+k;
      fprintf(fp,"%5x",wN10V[i]);
      if (i==7) fprintf(fp,"\n");
      if (i==15) fprintf(fp,"\n");
       }
    if ((i>=16)&&(i<32))
       {
       EEP_READ(i,&j,&k);
       wP10V[i-16]=(j<<8)+k;
       fprintf(fp,"%5x",wP10V[i-16]);
       if (i==23) fprintf(fp,"\n");
       if (i==31) fprintf(fp,"\n");
       }
    if ((i>=32)&&(i<48))
       {
       EEP_READ(i,&j,&k);
       w00mA[i-32]=(j<<8)+k;
       fprintf(fp,"%5x",w00mA[i-32]);
       if (i==39) fprintf(fp,"\n");
       if (i==47) fprintf(fp,"\n");
       }
    if (i>=48)
       {
       EEP_READ(i,&j,&k);
       w20mA[i-48]=(j<<8)+k;
       fprintf(fp,"%5x",w20mA[i-48]);
       if (i==55) fprintf(fp,"\n");
       if (i==63) fprintf(fp,"\n");
       }





    }

fprintf(fp,"========================================\n");
fprintf(fp,"File name : %s",filename);

fclose(fp);

PIO_DriverClose();
}

/* D0 = CS of EEP  */
/* D1 = SK of EEP  */
/* D2 = DI of EEP  */
/* D0 = DO of EEP  */

COMM()	/* send start 2-bit (0,1)  */
{
EepData=4; outportb(EepAddr,EepData); /* CS=L, SK=L, DI=H */
EepData=5; outportb(EepAddr,EepData); /* CS=H, SK=L, DI=H */
EepData=7; outportb(EepAddr,EepData); /* CS=H, SK=H, DI=H */
EepData=5; outportb(EepAddr,EepData); /* CS=H, SK=L, DI=H */
}

WR_BYTE(int val)  /* send the next 8-bit */
{
int i,j;

for (i=0; i<8; i++)
    {
    EepData &= 5; outportb(EepAddr,EepData);	/* SK=L */

    j=val&0x80; val=val<<1;
    if (j==0)					/* DI=0 */
       {
       EepData &= 3; outportb(EepAddr,EepData); /* DI=L */
       }
    else					/* DI=1 */
       {
       EepData |= 4; outportb(EepAddr,EepData); /* DI=H */
       }

    EepData |= 2; outportb(EepAddr,EepData);	/* SK=H */
    }
}

RD_BYTE()   // read the next 8-bit
{
int i,j,val,k;

val=0x80; k=0;
for (i=0; i<8; i++)
    {
    EepData &= 5; outportb(EepAddr,EepData); /* SK=L */
    j=(inportb(EepAddr))&8;
    if (j!=0) k+=val;			     /* DO=1 */
    EepData |= 2; outportb(EepAddr,EepData); /* SK=H */
    val=val>>1;
    }
return(k);
}

/* ---------------------------------------------------------------*/

EEP_WR_EN()   /* write Enable */
{
COMM();
WR_BYTE(0x30);				 /* write enable command */
EepData &= 5; outportb(EepAddr,EepData); /* SK=L                 */
EepData &= 6; outportb(EepAddr,EepData); /* CS=L                 */
EepData &= 3; outportb(EepAddr,EepData); /* DI=L                 */
}

/* ---------------------------------------------------------------*/

EEP_WR_DIS()  /* write Disable */
{
COMM();
WR_BYTE(0);				 /* write enable command   */
EepData &= 5; outportb(EepAddr,EepData); /* SK=L		   */
EepData &= 6; outportb(EepAddr,EepData); /* CS=L		   */
EepData &= 3; outportb(EepAddr,EepData); /* DI=L		   */
}

/* --------------------------------------------------------------- */

EEP_WRITE(int ADDR, int HI, int LO)  /* write 16-bit data to EEP   */
{
int i,j,k;

COMM();
ADDR=ADDR|0x40; WR_BYTE(ADDR);		/* write command & address */
WR_BYTE(HI);				/* high 8-bit data	   */
WR_BYTE(LO);				/* low	8-bit data	   */

EepData &= 5; outportb(EepAddr,EepData);/* SK=L 		   */
EepData &= 6; outportb(EepAddr,EepData);/* CS=L 		   */
EepData &= 3; outportb(EepAddr,EepData);/* DI=L 		   */

for (i=0; i<10; i++)			/* delay for EEP	   */
    {
    outportb(EepAddr,EepData);
    }

EepData |= 1; outportb(EepAddr,EepData);/* CS=H 		   */

for (k=0;k<10;k++)
for (i=0;i<32767;i++)
    {
    EepData |= 2; outportb(EepAddr,EepData); /* SK=H */
    j=(inportb(EepAddr))&8;
    EepData &= 5; outportb(EepAddr,EepData); /* SK=L */

    if (j!=0)
       {
       EepData &= 6; outportb(EepAddr,EepData); /* CS=L */
       return(0);
       }
    }

err_label:
EepData=0; outportb(EepAddr,EepData); /* CS=L, SK=L, DI=L */
return(1);
}

/* --------------------------------------------------------------- */

EEP_READ(int ADDR, int *HI, int *LO) /* read 16-bit data from EEP  */
{
int i,j,k;

COMM();
ADDR=ADDR|0x80; WR_BYTE(ADDR);		/* read command & address  */

EepData &= 3; outportb(EepAddr,EepData);/* DI=L 		   */
EepData &= 5; outportb(EepAddr,EepData);/* SK=L 		   */
EepData |= 2; outportb(EepAddr,EepData);/* SK=H 		   */
EepData &= 5; outportb(EepAddr,EepData);/* SK=L 		   */

(*HI)=RD_BYTE();			/* read high 8-bit data    */
(*LO)=RD_BYTE();			/* read low  8-bit data    */

EepData &= 5; outportb(EepAddr,EepData);/* SK=L 		   */
EepData &= 6; outportb(EepAddr,EepData);/* CS=L 		   */
}

