// ------------------------------------------------------------//
// DEMO 6 : Ad Pacer trigger with AD POLLING with no Calibation//
// Compiler: Turbo   C++ 3.0, Mode Large                       //
// ------------------------------------------------------------//

#include "PIO.H"

static int wSysConfig=0;
float fAdData[1000];
WORD  AdValue[1000];
WORD wBase,wIrq;
WORD wDELAY=23,time=0;


//---------------------------------------------------------
WORD Pio821_Delay(WORD wDownCount)
{
  WORD h,l;
  int count;
  wDownCount &= 0xff;
  if (wDownCount<1) wDownCount=1;

 // Clock in=2M --> count 4000 = 1 ms ,count 1 = 0.5 us
  l=wDownCount&0xff;
  wDownCount=wDownCount / 256;
  h=wDownCount&0xff;

  outportb(wBase+0xcc,0xb4);	             // CW of 8254,mode_0, counter_2
  outportb(wBase+0xc8,l);	             // counter_2 low byte first
  outportb(wBase+0xc8,h);	             // counter_2 high byte ,0x07D0=2000

  outportb(wBase+0xcc,0x80);	             // latch counter_2
  l=inportb(wBase+0xc8);	             // delay starting two clks
  h=inportb(wBase+0xc8);

  for (count=32767;count>0;count--)
  {
	  outportb(wBase+0xcc,0x80);         // latch counter_2
	  l=inportb(wBase+0xc8);
	  h=inportb(wBase+0xc8);
	  if (h>=0x80) return NoError;
  }
  return TimeOut;
}

//---------------------------------------------------
void SetupTimer(WORD wCoef)
{
   WORD   cmd,lsb,msb;
   outportb(wBase+0xcc, 0xb4);
   outportb(wBase+0xc8, wCoef&0xff);
   outportb(wBase+0xc8, wCoef>>8);
}

//-------------------------------------------------------
WORD Pio821_AdsPacer(float fAdVal[],WORD wNum, WORD wSamplingDiv)
{
   WORD    wVal,wZERO,i;
   WORD    MSB,LSB,wTime,sts;
   float   fMAX;

   switch (wSysConfig)
   {
       case 0 :  fMAX=(float)5.0  ;   break;
       case 1 :  fMAX=(float)2.5  ;   break;
       case 2 :  fMAX=(float)1.25 ;   break;
       case 3 :  fMAX=(float)0.625;   break;
   }

   outportb(wBase+0xe4,0xf2);      // Set trigger mode=Pacer trigger
   SetupTimer(wSamplingDiv);       // sampling rate=2M/wSamplingDiv

   for(i=0;i<wNum;i++)
   {

	do{
		sts=inportb(wBase+0xec);
	}while((sts&0x01)==0);

      MSB=inportb(wBase+0xd4);
      LSB=inportb(wBase+0xd0);

   fAdVal[i]=(((float)(((MSB<<8)+LSB)&0xfff)-2048.0)/2048.0)*fMAX;
  }

  outportb(wBase+0xe4,0xf0);        		  // close Mode
}

//-------------------------------------------------------
WORD  Pio821_SetChannelConfig(WORD wAdChannel,WORD wConfig)
{

	WORD wDELAY;
	outportb(wBaseAddr+0x10,(UCHAR)wAdChannel);
	outportb(wBaseAddr+0x14,(UCHAR)wConfig);
	wSysConfig=wConfig;

	switch (wSysConfig)
	{
	 case 0 : wDELAY=23;      break;
	 case 1 : wDELAY=23;      break;
	 case 2 : wDELAY=23;      break;
	 case 3 : wDELAY=23;      break;

	 case 0x10 : wDELAY=23;   break;
	 case 0x11 : wDELAY=28;   break;
	 case 0x12 : wDELAY=140;  break;
	 case 0x13 : wDELAY=1300; break;
      }
     // P1002_Delay(wDELAY*4);
	return NoError;
	outportb(wBase+0xe0,wAdChannel);
	Pio821_Delay(wDELAY *4);
	return NoError;
}



int main(void)
{
int  i,j,k1,k2,l1,l2,jj,dd,j1,i1,j2,i2;
int  t=0,quit=0;

WORD wBoards,wRetVal,t1,t2,t3,t4,t5,High;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c,DO,ReadBack;
FILE *stream;

clrscr();
// Step 1: Find address-mapping of PIO/PISO cards
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);

printf("\nThere are %d PIO-821 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");

for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }
PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

printf("\n\nAd Pacer trigger with AD POLLING with no Calibation");
printf("\nPress any key to start");
getch();


// Step 2: Enable all D/I/O port
outportb(wBase,0X31);	        	     // enable D/I/O
outportb(wBase+0xe0,0);                      // Set channel=0,Gain=0

Pio821_AdsPacer(fAdData,1000,40);          // Sample Rate= 2Mhz/200 = 10k Max

stream=fopen("data.dat","wb+");
for(i=0;i<1000;i++)
   {
    fprintf(stream,"%2.5f\n",fAdData[i]);
   }

PIO_DriverClose();
clrscr();
printf("Data already save to data.dat");
}

