/* ------------------------------------------------------------ */
/* DEMO5   : PIO-821 AD POLLING  with software trigger          */
/* Note    : Measure Single 8-channel A/I.unipolar range:       */
/*           0V -- +/-5V                                        */
/* ------------------------------------------------------------ */
#include "PIO.H"

static int wSysConfig=0;
float fAdVal[1000];
WORD AdVal[1000];


WORD wBase,wIrq;
WORD wDELAY=23,time=0;


//-------------------------------------------------------
WORD Pio821_Delay(WORD wDownCount)
{
  WORD h,l;
  int count;

  wDownCount &= 0x7fff;
  if (wDownCount<1) wDownCount=1;
  // Clock in=2M --> count 2000 = 1 ms ,count 1 = 0.5 us

  l=wDownCount&0xff;
  wDownCount=wDownCount / 256;
  h=wDownCount&0xff;

  outportb(wBase+0xcc,0x30);          // mode_0, counter_2
  outportb(wBase+0xc8,l);	      // counter_2 low byte first
  outportb(wBase+0xc8,h);	      // counter_2 high byte ,0x07D0=2000

  outportb(wBase+0xcc,0x00);          // latch counter_2

  l=inportb(wBase+0xc8);              // delay starting two clks
  h=inportb(wBase+0xc8);

  for (count=32767;count>0;count--)
  {
	  outportb(wBase+0xcc,0x00);	 // latch counter_2
	  l=inportb(wBase+0xc8);
	  h=inportb(wBase+0xc8);
	  if (h>=0x80) return NoError;
  }
  return TimeOut;
}

//--------------------------------------------------------

void SetupTimer(WORD wChannel, WORD wCoef)
{
   WORD   cmd;

   outportb(wBase+0xcc, 0xb4);
   outportb(wBase+0xc8, (UCHAR)(wCoef&0xff));
   outportb(wBase+0xc8, (UCHAR)(wCoef>>8));
}



int main()
{
int i,x,y,j,quit=0;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
WORD sts,MSB,LSB,wAdData;
char c,DO,ReadBack;
float k;
FILE *fp;

clrscr();

/* step 1: find address-mapping of PIO/PISO cards  */
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);  /* for PIO-821 */
printf("\nThere are %d PIO-821 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
       {
	  PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
	  &wSubAux,&wSlotBus,&wSlotDevice);
	  printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
	  printf(" --> ");
	  ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
       }
PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);
/* step2 : enable all D/I/O port   */

printf("\n\nPIO-821 AD POLLING  with software trigger");
printf("\nPerss any key to start");
getch();


outportb(wBase,0x31);              // /RESET -> 1

/*for(;;)
	{
	for(i=0;i<1000;i++) Pio821_Delay(2000);
	printf("*");
	if(kbhit()!=0) {getch();return;}
	}

*/
outportb(wBase+0xe0,0x00);      // channel=0 ; G=1
Pio821_Delay(23);

outportb(wBase+0xe4,0xf1);      // Select trigger mode=Software-trigge

for(i=0;i<1000;i++)
   {
    outportb(wBase+0xe8,0x01);    // A/D software tirgger
    do {
	sts=inportb(wBase+0xec);  //Check status until sts=1
       }while((sts&0x01)==0);

      MSB=inportb(wBase+0xd4);
      LSB=inportb(wBase+0xd0);

   fAdVal[i]=(((float)(((MSB<<8)+LSB)&0xfff)-2048.0)/2048.0)*5.0;

  }

    outportb(wBase+0xe4,0xf0);          // close mode

fp=fopen("data.dat","wb+");
for(i=0;i<1000;i++)
{
   fprintf(fp,"%2.5f\n",fAdVal[i]);
}

PIO_DriverClose();
clrscr();
printf("Data already save to data.dat");
}



