// -------------------------------------------------------------- //
// DEMO2.C : Square Wave Generator                            	  //
// Step 1  : clk select INT_CLK=2M(JP5),JP6 select Ext_GATE   	  //
// Step 2  : Run DEMO2.exe                                        //
// Step 3  : Check cout0,cout1,cout2 by scope                     //
// -------------------------------------------------------------- //

#include "PIO.H"

#define COUNT0                  0xc0
#define COUNT1                  0xc4
#define COUNT2                  0xc8
#define CW                      0xcc

WORD wBase,wIrq;
WORD C0_L,C0_H,C1_L,C1_H,C2_L,C2_H;

WORD PIO821_8254_C0(char cConfig ,char cLow,char cHigh)

{
   outportb(wBase+CW,cConfig);                      // Counter 0
   outportb(wBase+COUNT0,cLow);
   outportb(wBase+COUNT0,cHigh);
   return(NoError);
}

WORD PIO821_8254_C1(char cConfig ,char cLow,char cHigh)
{
  outportb(wBase+CW,cConfig);                       // Counter 1
  outportb(wBase+COUNT1,cLow);
  outportb(wBase+COUNT1,cHigh);
  return(NoError);

}

void PIO821_8254_C2(char cConfig ,char cLow,char cHigh)
{
  outportb(wBase+CW,cConfig);                    // Counter 2
  outportb(wBase+COUNT2,cLow);
  outportb(wBase+COUNT2,cHigh);
  return(NoError);

}


int main()
{
int i,i1,i2,c1,c2;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c,DO,ReadBack;

clrscr();
// step 1: find address-mapping of PIO/PISO cards
wRetVal=PIO_DriverInit(&wBoards,0x40ff,0x03,0x10);  // for PIO-821
printf("\nThere are %d PIO-821 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

printf("\n\nClk select INT_CLK=2M(JP5),JP6 select Ext_GATE");
printf("\nCheck cout0,cout1,cout2 with scope");
printf("\nPress any key to start");
getch();

// step2 : enable all D/I/O port
outportb(wBase,1);                                // /RESET->1

printf("\n Square Wave Generator for COUT0 to COUT2");

PIO821_8254_C0(0x36,2,0);  //Cout0,Mode3 Cout=1M
PIO821_8254_C1(0x76,4,0);  //Cout1,Mode3 Cout=500K
PIO821_8254_C2(0xb6,8,0);  //Cout2,Mode3 Cout=250K
printf("\n\n COUT0 =1M ; COUT1=500K ; COUT2=250K  Press any key to quit");
getch();
PIO821_8254_C0(0x30,0,0);  //Cout0,Mode3 Cout=0
PIO821_8254_C1(0x70,0,0);  //Cout1,Mode3 Cout=0
PIO821_8254_C2(0xb0,0,0);  //Cout2,Mode3 Cout=0
PIO_DriverClose();

}





